# Guidelines for Adding Issues to SparkPost
Thank you for finding an issue, the SparkPost SDKs are open sourced and focused on helping our developers to be successful. Please review the following checklist before submitting a new issue.

1. To prevent duplication, please [search for issues](https://github.com/SparkPost/node-sparkpost/issues) and make sure it doesn’t already exist
2. Please provide the following information to help our contributors in resolving the issue:
    1. Operating System and Version
    2. Programming language version
    3. Exception, error or issue summary
    4. Recreation steps or Use case summary
    5. Example data (if available)
    6. Expected result or desired functionality
    7. Any extra information you’d like to provide
3. Please give your issue a meaningful name
4. Please, no trolling or flaming comments on issues (counter-productive)
5. Please follow/watch your issue. We expect you to take issue reporting as seriously as we do.
